<?php

namespace Acts\CamdramApiBundle\Entity;

use Acts\CamdramSecurityBundle\Entity\User;
use Doctrine\ORM\EntityRepository;

/**
 * ExternalAppRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 * @extends EntityRepository<ExternalApp>
 */
class ExternalAppRepository extends EntityRepository
{
    public function findByUser(User $user)
    {
        return $this->createQueryBuilder('a')
            ->where('a.user = :user')
            ->orderBy('a.name')
            ->setParameter('user', $user)
            ->getQuery()->getResult();
    }

    public function getByUserAndId(User $user, $id)
    {
        return $this->createQueryBuilder('a')
            ->where('a.user = :user')
            ->andWhere('a.randomId = :id')
            ->setParameter('id', $id)
            ->setParameter('user', $user)
            ->getQuery()->getOneOrNullResult();
    }

    public function findByCredentials($id, $clientId, $clientSecret)
    {
        return $this->createQueryBuilder('a')
            ->where('a.id = :id')
            ->andWhere('a.randomId = :clientid')
            ->andWhere('a.secret = :clientsecret')
            ->setParameter('id', $id)
            ->setParameter('clientid', $clientId)
            ->setParameter('clientsecret', $clientSecret)
            ->getQuery()->getOneOrNullResult();
    }
}
